import { Builder, resolveValueOrUpdateCallback } from "../builder.js";
/**
 * @alpha
 */
export class WidgetBaseBuilder extends Builder {
    setWidget = (updateCallback) => {
        this.item = updateCallback(this.item);
        return this;
    };
    setWidgetProp = (prop, valueOrUpdateCallback) => {
        this.setWidget((w) => ({
            ...w,
            [prop]: resolveValueOrUpdateCallback(valueOrUpdateCallback, w[prop]),
        }));
        return this;
    };
    title = (valueOrUpdateCallback) => this.setWidgetProp("title", valueOrUpdateCallback);
    description = (valueOrUpdateCallback) => this.setWidgetProp("description", valueOrUpdateCallback);
    ignoreDashboardFilters = (valueOrUpdateCallback) => this.setWidgetProp("ignoreDashboardFilters", valueOrUpdateCallback);
    dateDataSet = (valueOrUpdateCallback) => this.setWidgetProp("dateDataSet", valueOrUpdateCallback);
    ref = (valueOrUpdateCallback) => this.setWidgetProp("ref", valueOrUpdateCallback);
    id = (valueOrUpdateCallback) => this.setWidgetProp("identifier", valueOrUpdateCallback);
    uri = (valueOrUpdateCallback) => this.setWidgetProp("uri", valueOrUpdateCallback);
}
//# sourceMappingURL=widgetFactory.js.map